'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Parser = require('./Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _Element = require('./components/Element');

var _Element2 = _interopRequireDefault(_Element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var Markup = function (_React$PureComponent) {
  (0, _inherits3.default)(Markup, _React$PureComponent);

  function Markup() {
    (0, _classCallCheck3.default)(this, Markup);
    return (0, _possibleConstructorReturn3.default)(this, (Markup.__proto__ || (0, _getPrototypeOf2.default)(Markup)).apply(this, arguments));
  }

  (0, _createClass3.default)(Markup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          content = _props.content,
          noHtml = _props.noHtml,
          noHtmlExceptMatchers = _props.noHtmlExceptMatchers,
          disableLineBreaks = _props.disableLineBreaks,
          disableWhitelist = _props.disableWhitelist,
          emptyContent = _props.emptyContent,
          tagName = _props.tagName;

      var className = noHtml || noHtmlExceptMatchers ? 'interweave--no-html' : '';
      var markup = new _Parser2.default(content, {
        noHtml: noHtml,
        noHtmlExceptMatchers: noHtmlExceptMatchers,
        disableLineBreaks: disableLineBreaks,
        disableWhitelist: disableWhitelist
      }).parse();

      return _react2.default.createElement(
        _Element2.default,
        { tagName: tagName, className: className },
        markup.length ? markup : emptyContent
      );
    }
  }]);
  return Markup;
}(_react2.default.PureComponent);

Markup.propTypes = {
  content: _propTypes2.default.string,
  disableLineBreaks: _propTypes2.default.bool,
  disableWhitelist: _propTypes2.default.bool,
  emptyContent: _propTypes2.default.node,
  noHtml: _propTypes2.default.bool,
  noHtmlExceptMatchers: _propTypes2.default.bool,
  tagName: _propTypes2.default.oneOf(['span', 'div', 'p'])
};
Markup.defaultProps = {
  content: '',
  disableLineBreaks: false,
  disableWhitelist: false,
  emptyContent: null,
  noHtml: false,
  noHtmlExceptMatchers: false,
  tagName: 'span'
};
exports.default = Markup;