'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _emojibase = require('emojibase');

var _EmojiData = require('../data/EmojiData');

var _EmojiData2 = _interopRequireDefault(_EmojiData);

var _shapes = require('../shapes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LARGE_MULTIPLIER = 3; /**
                           * @copyright   2016, Miles Johnson
                           * @license     https://opensource.org/licenses/MIT
                           * 
                           */

var Emoji = function (_React$PureComponent) {
  (0, _inherits3.default)(Emoji, _React$PureComponent);

  function Emoji() {
    (0, _classCallCheck3.default)(this, Emoji);
    return (0, _possibleConstructorReturn3.default)(this, (Emoji.__proto__ || (0, _getPrototypeOf2.default)(Emoji)).apply(this, arguments));
  }

  (0, _createClass3.default)(Emoji, [{
    key: 'render',
    value: function render() {
      var data = _EmojiData2.default.getInstance(this.context.emoji.locale);
      var _props = this.props,
          emojiLargeSize = _props.emojiLargeSize,
          emojiPath = _props.emojiPath,
          emojiSize = _props.emojiSize,
          emoticon = _props.emoticon,
          enlargeEmoji = _props.enlargeEmoji,
          shortcode = _props.shortcode;
      var unicode = this.props.unicode;


      if ("production" !== process.env.NODE_ENV) {
        if (!emoticon && !shortcode && !unicode) {
          throw new Error('Emoji component requires a `unicode` character, `emoticon`, or a `shortcode`.');
        }
      }

      if (!unicode && shortcode) {
        unicode = data.SHORTCODE_TO_UNICODE[shortcode];
      }

      if (!unicode && emoticon) {
        unicode = data.EMOTICON_TO_UNICODE[emoticon];
      }

      if (!unicode || !data.EMOJIS[unicode]) {
        return _react2.default.createElement(
          'span',
          null,
          unicode || emoticon || shortcode
        );
      }

      var emoji = data.EMOJIS[unicode];
      var className = ['interweave__emoji'];
      var styles = {};

      if (emojiSize) {
        styles.display = 'inline-block';
        styles.verticalAlign = 'middle';
        styles.width = emojiSize + 'em';
      }

      if (enlargeEmoji) {
        className.push('interweave__emoji--large');

        if (emojiLargeSize) {
          styles.width = emojiLargeSize + 'em';
        } else if (emojiSize) {
          styles.width = emojiSize * LARGE_MULTIPLIER + 'em';
        }
      }

      var path = emojiPath || '{{hexcode}}';

      if (typeof path === 'function') {
        path = path(emoji.hexcode, enlargeEmoji, emojiSize, emojiLargeSize);
      } else {
        path = path.replace('{{hexcode}}', emoji.hexcode);
      }

      return _react2.default.createElement('img', {
        src: path,
        alt: unicode,
        title: emoji.annotation || '',
        style: styles,
        className: className.join(' '),
        'aria-label': emoji.annotation || '',
        'data-emoticon': emoji.emoticon || '',
        'data-unicode': unicode,
        'data-hexcode': emoji.hexcode,
        'data-shortcodes': data.UNICODE_TO_SHORTCODES[unicode].join(', '),
        'data-codepoint': (0, _emojibase.fromHexcodeToCodepoint)(emoji.hexcode).join('-')
      });
    }
  }]);
  return Emoji;
}(_react2.default.PureComponent);

Emoji.contextTypes = {
  emoji: _shapes.EmojiContextShape.isRequired
};
Emoji.propTypes = {
  emojiLargeSize: _propTypes2.default.number,
  emojiPath: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
  emojiSize: _propTypes2.default.number,
  emoticon: _propTypes2.default.string,
  enlargeEmoji: _propTypes2.default.bool,
  shortcode: _propTypes2.default.string,
  unicode: _propTypes2.default.string
};
Emoji.defaultProps = {
  emojiLargeSize: 0,
  emojiPath: '{{hexcode}}',
  emojiSize: 0,
  emoticon: '',
  enlargeEmoji: false,
  shortcode: '',
  unicode: ''
};
exports.default = Emoji;