'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _emojibase = require('emojibase');

var _constants = require('emojibase/lib/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var instances = {};
var EmojiData = function () {
  function EmojiData(locale) {
    (0, _classCallCheck3.default)(this, EmojiData);
    this.EMOJIS = {};
    this.EMOTICON_TO_UNICODE = {};
    this.SHORTCODE_TO_UNICODE = {};
    this.UNICODE_TO_SHORTCODES = {};
    this.data = [];
    this.flatData = [];
    this.locale = 'en';

    this.locale = locale;
  }

  (0, _createClass3.default)(EmojiData, [{
    key: 'getData',
    value: function getData() {
      return this.data;
    }
  }, {
    key: 'getFlatData',
    value: function getFlatData() {
      return this.flatData;
    }
  }, {
    key: 'packageEmoji',
    value: function packageEmoji(emoji) {
      var _this = this;

      var emoticon = emoji.emoticon,
          shortcodes = emoji.shortcodes;

      var unicode = emoji.text && emoji.type === _constants.TEXT ? emoji.text : emoji.emoji;
      emoji.unicode = unicode;

      emoji.canonical_shortcodes = shortcodes.map(function (code) {
        return ':' + code + ':';
      });
      emoji.primary_shortcode = emoji.canonical_shortcodes[0];
      this.UNICODE_TO_SHORTCODES[unicode] = emoji.canonical_shortcodes.map(function (shortcode) {
        _this.SHORTCODE_TO_UNICODE[shortcode] = unicode;

        return shortcode;
      });

      if (emoticon) {
        (0, _emojibase.generateEmoticonPermutations)(emoticon, _constants.EMOTICON_OPTIONS[emoticon]).forEach(function (emo) {
          _this.EMOTICON_TO_UNICODE[emo] = unicode;
        });
      }

      this.EMOJIS[unicode] = emoji;

      return emoji;
    }
  }, {
    key: 'parseEmojiData',
    value: function parseEmojiData(data) {
      var _this2 = this;

      data.forEach(function (emoji) {
        var packagedEmoji = _this2.packageEmoji(emoji);

        _this2.data.push(packagedEmoji);
        _this2.flatData.push(packagedEmoji);

        if (packagedEmoji.skins) {
          packagedEmoji.skins.forEach(function (skin) {
            _this2.flatData.push(_this2.packageEmoji(skin));
          });
        }
      });

      return this.data;
    }
  }], [{
    key: 'getInstance',
    value: function getInstance(locale) {
      if (!instances[locale]) {
        instances[locale] = new EmojiData(locale);
      }

      return instances[locale];
    }
  }]);
  return EmojiData;
}();

exports.default = EmojiData;