'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.resetLoaded = resetLoaded;
exports.default = withEmojiData;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _emojibase = require('emojibase');

var _constants = require('emojibase/lib/constants');

var _EmojiData = require('../data/EmojiData');

var _EmojiData2 = _interopRequireDefault(_EmojiData);

var _shapes = require('../shapes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var loaded = {};
var promise = {};

function resetLoaded() {
  if ("production" !== process.env.NODE_ENV) {
    loaded = {};
    promise = {};
  }
}

function withEmojiData(Component) {
  var _class, _temp2;

  return _temp2 = _class = function (_React$Component) {
    (0, _inherits3.default)(EmojiLoader, _React$Component);

    function EmojiLoader() {
      var _ref;

      var _temp, _this, _ret;

      (0, _classCallCheck3.default)(this, EmojiLoader);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = EmojiLoader.__proto__ || (0, _getPrototypeOf2.default)(EmojiLoader)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        emojis: []
      }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(EmojiLoader, [{
      key: 'getChildContext',
      value: function getChildContext() {
        var _props = this.props,
            compact = _props.compact,
            locale = _props.locale,
            version = _props.version;


        return {
          emoji: {
            compact: compact,
            locale: locale,
            version: version
          }
        };
      }
    }, {
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _this2 = this;

        var _props2 = this.props,
            compact = _props2.compact,
            emojis = _props2.emojis,
            locale = _props2.locale,
            version = _props2.version;

        var data = this.getDataInstance();

        if (loaded[locale]) {
          this.setState({
            emojis: data.getData()
          });
        } else if (emojis.length > 0) {
          this.loadData(emojis);
        } else if (promise[locale]) {
          promise[locale].then(function () {
            _this2.setState({
              emojis: data.getData()
            });
          }).catch(function (error) {
            throw error;
          });
        } else {
          promise[locale] = (0, _emojibase.fetchFromCDN)(locale + '/' + (compact ? 'compact' : 'data') + '.json', version).then(function (response) {
            _this2.loadData(response);
          }).catch(function (error) {
            throw error;
          });
        }
      }
    }, {
      key: 'getDataInstance',
      value: function getDataInstance() {
        return _EmojiData2.default.getInstance(this.props.locale);
      }
    }, {
      key: 'loadData',
      value: function loadData(data) {
        this.setState({
          emojis: this.getDataInstance().parseEmojiData(Array.isArray(data) ? data : JSON.parse(data))
        });

        loaded[this.props.locale] = true;
      }
    }, {
      key: 'render',
      value: function render() {
        var _props3 = this.props,
            compact = _props3.compact,
            emojis = _props3.emojis,
            locale = _props3.locale,
            version = _props3.version,
            props = (0, _objectWithoutProperties3.default)(_props3, ['compact', 'emojis', 'locale', 'version']);


        return _react2.default.createElement(Component, (0, _extends3.default)({}, props, { emojis: this.state.emojis }));
      }
    }]);
    return EmojiLoader;
  }(_react2.default.Component), _class.childContextTypes = {
    emoji: _shapes.EmojiContextShape
  }, _class.propTypes = {
    compact: _propTypes2.default.bool,
    emojis: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.object)]),
    locale: _propTypes2.default.oneOf(_constants.SUPPORTED_LOCALES),
    version: _propTypes2.default.string
  }, _class.defaultProps = {
    compact: false,
    emojis: [],
    locale: 'en',
    version: 'latest'
  }, _temp2;
}