'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmojiPathShape = exports.EmojiShape = exports.EmojiContextShape = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constants = require('emojibase/lib/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var EmojiContextShape = exports.EmojiContextShape = _propTypes2.default.shape({
  compact: _propTypes2.default.bool.isRequired,
  locale: _propTypes2.default.oneOf(_constants.SUPPORTED_LOCALES).isRequired,
  version: _propTypes2.default.string.isRequired
});

var EmojiShape = exports.EmojiShape = _propTypes2.default.shape({
  annotation: _propTypes2.default.string,
  canonical_shortcodes: _propTypes2.default.arrayOf(_propTypes2.default.string),
  emoji: _propTypes2.default.string,
  emoticon: _propTypes2.default.string,
  gender: _propTypes2.default.number,
  group: _propTypes2.default.number,
  hexcode: _propTypes2.default.string,
  name: _propTypes2.default.string,
  order: _propTypes2.default.number,
  primary_shortcode: _propTypes2.default.string,
  shortcodes: _propTypes2.default.arrayOf(_propTypes2.default.string),
  subgroup: _propTypes2.default.number,
  tags: _propTypes2.default.arrayOf(_propTypes2.default.string),
  text: _propTypes2.default.string,
  tone: _propTypes2.default.number,
  unicode: _propTypes2.default.string
});

var EmojiPathShape = exports.EmojiPathShape = _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]);